<?php
// prevent XSS
$_GET   = filter_input_array(INPUT_GET, FILTER_SANITIZE_STRING);
$_POST  = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);
$bucket = 'https://indeval-webdocs-publico-01122020.s3.amazonaws.com/';

///////////ESPAÑOL

    $time = time();
    $company_es = trim($_POST['company_es']);
    $company_es = strip_tags($company_es);
    $company_es = htmlspecialchars($company_es);

    $fecha_es = trim($_POST['fecha_es']);
    $fecha_es = strip_tags($fecha_es);
    $fecha_es = htmlspecialchars($fecha_es);

    $fecha_es = str_replace('/','-', $fecha_es);
    $nueva_fecha_es = $fecha_es . " 00:00:00";

    $fecha_es= date("c", strtotime($nueva_fecha_es));

    $resumen_es = trim($_POST['resumen_es']);
    $resumen_es = urlencode($resumen_es);//WYSIWYG Editor
    $resumen_es = strip_tags($resumen_es);
    $resumen_es = htmlspecialchars($resumen_es);

    $titulo_es = trim($_POST['titulo_es']);
    $titulo_es = strip_tags($titulo_es);
    $titulo_es = htmlspecialchars($titulo_es);

    $nombrearchivo_es = str_replace(' ','-', $titulo_es);

    $logo_es = '';
    $archivo_es = '';

    //////////////SUBIR LOGO
    if($_FILES['logo_es']['size'] > 0){

        if (isset($_FILES['logo_es']) && $_FILES['logo_es']['error'] === UPLOAD_ERR_OK)
        {
            // get details of the uploaded file
            $fileTmpPath = $_FILES['logo_es']['tmp_name'];
            $fileName = $_FILES['logo_es']['name'];
            $fileSize = $_FILES['logo_es']['size'];
            $fileType = $_FILES['logo_es']['type'];
            $fileNameCmps = explode(".", $fileName);
            $fileExtension = strtolower(end($fileNameCmps));
        
            // sanitize file-name
            $newFileName = "DividendoEventoSic_es_".$time. '.' . $fileExtension;

            // check if file has one of the following extensions
            $allowedfileExtensions = array('jpg', 'gif', 'png', 'webp', 'svg');
        
            if (in_array($fileExtension, $allowedfileExtensions))
            {
            ///////////////SUBIR A AWS
                /// AWS API keys
                $aws_access_key_id = 'AKIA4EFX4JXF3WUEDZUY';
                $aws_secret_access_key = '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';
                // Bucket
                $bucket_name = 'indeval-webdocs-publico-01122020';
                // AWS region and Host Name (Host names are different for each AWS region)
                // As an example these are set to us-east-1 (US Standard)
                $aws_region = 'us-east-1';
                $host_name = $bucket_name . '.s3.amazonaws.com';

                // Server path where content is present. This is just an example
                //$content_path = $dest_path;
                $content = file_get_contents($fileTmpPath);

                // AWS file permissions
                $content_acl = 'public-read';

                // MIME type of file. Very important to set if you later plan to load the file from a S3 url in the browser (images, for example)
                $content_type = 'image/'.$fileExtension;

                if($content_type == 'image/svg' ){ $content_type = "image/svg+xml";}
                // Name of content on S3
                $content_title = 'img/estadisticas-informacion/avisos-depositantes/'.$newFileName;

                // Service name for S3
                $aws_service_name = 's3';

                // UTC timestamp and date
                $timestamp = gmdate('Ymd\THis\Z');
                $date = gmdate('Ymd');

                // HTTP request headers as key & value
                $request_headers = array();
                $request_headers['Content-Type'] = $content_type;
                $request_headers['Date'] = $timestamp;
                $request_headers['Host'] = $host_name;
                $request_headers['x-amz-acl'] = $content_acl;
                $request_headers['x-amz-content-sha256'] = hash('sha256', $content);
                // Sort it in ascending order
                ksort($request_headers);

                // Canonical headers
                $canonical_headers = [];
                foreach($request_headers as $key => $value) {
                    $canonical_headers[] = strtolower($key) . ":" . $value;
                }
                $canonical_headers = implode("\n", $canonical_headers);

                // Signed headers
                $signed_headers = [];
                foreach($request_headers as $key => $value) {
                    $signed_headers[] = strtolower($key);
                }
                $signed_headers = implode(";", $signed_headers);

                // Cannonical request 
                $canonical_request = [];
                $canonical_request[] = "PUT";
                $canonical_request[] = "/" . $content_title;
                $canonical_request[] = "";
                $canonical_request[] = $canonical_headers;
                $canonical_request[] = "";
                $canonical_request[] = $signed_headers;
                $canonical_request[] = hash('sha256', $content);
                $canonical_request = implode("\n", $canonical_request);
                $hashed_canonical_request = hash('sha256', $canonical_request);

                // AWS Scope
                $scope = [];
                $scope[] = $date;
                $scope[] = $aws_region;
                $scope[] = $aws_service_name;
                $scope[] = "aws4_request";

                // String to sign
                $string_to_sign = [];
                $string_to_sign[] = "AWS4-HMAC-SHA256"; 
                $string_to_sign[] = $timestamp; 
                $string_to_sign[] = implode('/', $scope);
                $string_to_sign[] = $hashed_canonical_request;
                $string_to_sign = implode("\n", $string_to_sign);

                // Signing key
                $kSecret = 'AWS4' . $aws_secret_access_key;
                $kDate = hash_hmac('sha256', $date, $kSecret, true);
                $kRegion = hash_hmac('sha256', $aws_region, $kDate, true);
                $kService = hash_hmac('sha256', $aws_service_name, $kRegion, true);
                $kSigning = hash_hmac('sha256', 'aws4_request', $kService, true);

                // Signature
                $signature = hash_hmac('sha256', $string_to_sign, $kSigning);

                // Authorization
                $authorization = [
                    'Credential=' . $aws_access_key_id . '/' . implode('/', $scope),
                    'SignedHeaders=' . $signed_headers,
                    'Signature=' . $signature
                ];
                $authorization = 'AWS4-HMAC-SHA256' . ' ' . implode( ',', $authorization);

                // Curl headers
                $curl_headers = [ 'Authorization: ' . $authorization ];
                foreach($request_headers as $key => $value) {
                    $curl_headers[] = $key . ": " . $value;
                }

                $url = 'https://' . $host_name . '/' . $content_title;
                $ch = curl_init($url);
                curl_setopt($ch, CURLOPT_HEADER, false);
                curl_setopt($ch, CURLOPT_HTTPHEADER, $curl_headers);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, false);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
                curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
                curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
                curl_setopt($ch, CURLOPT_POSTFIELDS, $content);
                curl_exec($ch);
                $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
                if($http_code != 200){
                    echo "Error AWS";
                }
                if($http_code == 200){
                    $logo_es = $bucket.$content_title;
                }
        
                
            }
            else
            {
                $message = '<p style="color:red; font-size:12px;">Extensión de imagen no válida. Verifica que tu archivo tenga uno de los siguientes formatos: ' . implode(', ', $allowedfileExtensions).'</p>';
                echo $message;
                exit();
            }
        }
        else
        {
            $message = '<p style="color:red; font-size:12px;">Error en subida de imagen (ES):<br></p> ';
            $message .= '<p style="color:red; font-size:12px;">Error:' . $_FILES['logo_es']['error'].'</p>';
            echo $message;
            exit();
        }
        echo $message;
    }


    //////////////SUBIR ARCHIVO

    if($_FILES['archivo_es']['size'] > 0){

        if (isset($_FILES['archivo_es']) && $_FILES['archivo_es']['error'] === UPLOAD_ERR_OK)
        {
            // get details of the uploaded file
            $fileTmpPath2 = $_FILES['archivo_es']['tmp_name'];
            $fileName2 = $_FILES['archivo_es']['name'];
            $fileSize2 = $_FILES['archivo_es']['size'];
            $fileType2 = $_FILES['archivo_es']['type'];
            $fileNameCmps2 = explode(".", $fileName2);
            $fileExtension2 = strtolower(end($fileNameCmps2));
        
            // sanitize file-name
            $newFileName2 = $nombrearchivo_es.$lang. '.' . $fileExtension2;

            // check if file has one of the following extensions
            $allowedfileExtensions2 = array('doc', 'docx', 'xls', 'xlsx', 'pdf', 'zip');
        
            if (in_array($fileExtension2, $allowedfileExtensions2))
            {
            ///////////////SUBIR A AWS
                /// AWS API keys
                $aws_access_key_id = 'AKIA4EFX4JXF3WUEDZUY';
                $aws_secret_access_key = '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';
                // Bucket
                $bucket_name = 'indeval-webdocs-publico-01122020';
                // AWS region and Host Name (Host names are different for each AWS region)
                // As an example these are set to us-east-1 (US Standard)
                $aws_region = 'us-east-1';
                $host_name = $bucket_name . '.s3.amazonaws.com';

                // Server path where content is present. This is just an example
                //$content_path = $dest_path;
                $content2 = file_get_contents($fileTmpPath2);

                // AWS file permissions
                $content_acl = 'public-read';

                // MIME type of file. Very important to set if you later plan to load the file from a S3 url in the browser (images, for example)
                
                $content_type2 = $fileExtension;

                if($content_type2 == 'image/svg' ){ $content_type2 = "image/svg+xml";}
                if($content_type2 == 'zip' ){ $content_type2 = "application/zip";}
                if($content_type2 == 'doc' || $content_type2 == 'docx' ){ $content_type2 = "application/msword";}
                if($content_type2 == 'xls' || $content_type2 == 'xlsx' ){ $content_type2 = "application/vnd.ms-excel";}
                // Name of content on S3
                $content_title2 = 'docs/dividendos/es/'.$newFileName2;

                // Service name for S3
                $aws_service_name = 's3';

                // UTC timestamp and date
                $timestamp = gmdate('Ymd\THis\Z');
                $date = gmdate('Ymd');

                // HTTP request headers as key & value
                $request_headers = array();
                $request_headers['Content-Type'] = $content_type2;
                $request_headers['Date'] = $timestamp;
                $request_headers['Host'] = $host_name;
                $request_headers['x-amz-acl'] = $content_acl;
                $request_headers['x-amz-content-sha256'] = hash('sha256', $content2);
                // Sort it in ascending order
                ksort($request_headers);

                // Canonical headers
                $canonical_headers = [];
                foreach($request_headers as $key => $value) {
                    $canonical_headers[] = strtolower($key) . ":" . $value;
                }
                $canonical_headers = implode("\n", $canonical_headers);

                // Signed headers
                $signed_headers = [];
                foreach($request_headers as $key => $value) {
                    $signed_headers[] = strtolower($key);
                }
                $signed_headers = implode(";", $signed_headers);

                // Cannonical request 
                $canonical_request = [];
                $canonical_request[] = "PUT";
                $canonical_request[] = "/" . $content_title2;
                $canonical_request[] = "";
                $canonical_request[] = $canonical_headers;
                $canonical_request[] = "";
                $canonical_request[] = $signed_headers;
                $canonical_request[] = hash('sha256', $content2);
                $canonical_request = implode("\n", $canonical_request);
                $hashed_canonical_request = hash('sha256', $canonical_request);

                // AWS Scope
                $scope = [];
                $scope[] = $date;
                $scope[] = $aws_region;
                $scope[] = $aws_service_name;
                $scope[] = "aws4_request";

                // String to sign
                $string_to_sign = [];
                $string_to_sign[] = "AWS4-HMAC-SHA256"; 
                $string_to_sign[] = $timestamp; 
                $string_to_sign[] = implode('/', $scope);
                $string_to_sign[] = $hashed_canonical_request;
                $string_to_sign = implode("\n", $string_to_sign);

                // Signing key
                $kSecret = 'AWS4' . $aws_secret_access_key;
                $kDate = hash_hmac('sha256', $date, $kSecret, true);
                $kRegion = hash_hmac('sha256', $aws_region, $kDate, true);
                $kService = hash_hmac('sha256', $aws_service_name, $kRegion, true);
                $kSigning = hash_hmac('sha256', 'aws4_request', $kService, true);

                // Signature
                $signature = hash_hmac('sha256', $string_to_sign, $kSigning);

                // Authorization
                $authorization = [
                    'Credential=' . $aws_access_key_id . '/' . implode('/', $scope),
                    'SignedHeaders=' . $signed_headers,
                    'Signature=' . $signature
                ];
                $authorization = 'AWS4-HMAC-SHA256' . ' ' . implode( ',', $authorization);

                // Curl headers
                $curl_headers = [ 'Authorization: ' . $authorization ];
                foreach($request_headers as $key => $value) {
                    $curl_headers[] = $key . ": " . $value;
                }

                $url = 'https://' . $host_name . '/' . $content_title2;
                $ch = curl_init($url);
                curl_setopt($ch, CURLOPT_HEADER, false);
                curl_setopt($ch, CURLOPT_HTTPHEADER, $curl_headers);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, false);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
                curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
                curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
                curl_setopt($ch, CURLOPT_POSTFIELDS, $content2);
                curl_exec($ch);
                $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
                if($http_code != 200){
                    echo "Error AWS";
                }
                if($http_code == 200){
                    $archivo_es = $bucket.$content_title2;
                }
        
                
            }
            else
            {
                $message = '<p style="color:red; font-size:12px;">Extensión de archivo no válida. Verifica que tu archivo tenga uno de los siguientes formatos: ' . implode(', ', $allowedfileExtensions).'</p>';
                echo $message;
                exit();
            }
        }
        else
        {
            $message = '<p style="color:red; font-size:12px;">Error en subida de archivo:<br></p> ';
            $message .= '<p style="color:red; font-size:12px;">Error:' . $_FILES['archivo_es']['error'].'</p>';
            echo $message;
            exit();
        }
        echo $message;
    }


    ///////////INGLÉS

    $time_en = time();
    $company_en = trim($_POST['company_en']);
    $company_en = strip_tags($company_en);
    $company_en = htmlspecialchars($company_en);

    $fecha_en = trim($_POST['fecha_en']);
    $fecha_en = strip_tags($fecha_en);
    $fecha_en = htmlspecialchars($fecha_en);

    $fecha_en = str_replace('/','-', $fecha_en);
    $nueva_fecha_en = $fecha_en . " 00:00:00";
    $fecha_en= date("c", strtotime($nueva_fecha_en));

    $resumen_en = trim($_POST['resumen_en']);
    $resumen_en = urlencode($resumen_en);//WYSIWYG Editor
    $resumen_en = strip_tags($resumen_en);
    $resumen_en = htmlspecialchars($resumen_en);

    $titulo_en = trim($_POST['titulo_en']);
    $titulo_en = strip_tags($titulo_en);
    $titulo_en = htmlspecialchars($titulo_en);

    $nombrearchivo_en = str_replace(' ','-', $titulo_en);

    $logo_en = '';
    $archivo_en = '';

    //////////////SUBIR LOGO
    if($_FILES['logo_en']['size'] > 0){

        if (isset($_FILES['logo_en']) && $_FILES['logo_en']['error'] === UPLOAD_ERR_OK)
        {
            // get details of the uploaded file
            $fileTmpPath = $_FILES['logo_en']['tmp_name'];
            $fileName = $_FILES['logo_en']['name'];
            $fileSize = $_FILES['logo_en']['size'];
            $fileType = $_FILES['logo_en']['type'];
            $fileNameCmps = explode(".", $fileName);
            $fileExtension = strtolower(end($fileNameCmps));
        
            // sanitize file-name
            $newFileName = "DividendoEventoSic_en_".$time. '.' . $fileExtension;

            // check if file has one of the following extensions
            $allowedfileExtensions = array('jpg', 'gif', 'png', 'webp', 'svg');
        
            if (in_array($fileExtension, $allowedfileExtensions))
            {
            ///////////////SUBIR A AWS
                /// AWS API keys
                $aws_access_key_id = 'AKIA4EFX4JXF3WUEDZUY';
                $aws_secret_access_key = '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';
                // Bucket
                $bucket_name = 'indeval-webdocs-publico-01122020';
                // AWS region and Host Name (Host names are different for each AWS region)
                // As an example these are set to us-east-1 (US Standard)
                $aws_region = 'us-east-1';
                $host_name = $bucket_name . '.s3.amazonaws.com';

                // Server path where content is present. This is just an example
                //$content_path = $dest_path;
                $content = file_get_contents($fileTmpPath);

                // AWS file permissions
                $content_acl = 'public-read';

                // MIME type of file. Very important to set if you later plan to load the file from a S3 url in the browser (images, for example)
                $content_type = 'image/'.$fileExtension;

                if($content_type == 'image/svg' ){ $content_type = "image/svg+xml";}
                // Name of content on S3
                $content_title = 'img/estadisticas-informacion/avisos-depositantes/'.$newFileName;

                // Service name for S3
                $aws_service_name = 's3';

                // UTC timestamp and date
                $timestamp = gmdate('Ymd\THis\Z');
                $date = gmdate('Ymd');

                // HTTP request headers as key & value
                $request_headers = array();
                $request_headers['Content-Type'] = $content_type;
                $request_headers['Date'] = $timestamp;
                $request_headers['Host'] = $host_name;
                $request_headers['x-amz-acl'] = $content_acl;
                $request_headers['x-amz-content-sha256'] = hash('sha256', $content);
                // Sort it in ascending order
                ksort($request_headers);

                // Canonical headers
                $canonical_headers = [];
                foreach($request_headers as $key => $value) {
                    $canonical_headers[] = strtolower($key) . ":" . $value;
                }
                $canonical_headers = implode("\n", $canonical_headers);

                // Signed headers
                $signed_headers = [];
                foreach($request_headers as $key => $value) {
                    $signed_headers[] = strtolower($key);
                }
                $signed_headers = implode(";", $signed_headers);

                // Cannonical request 
                $canonical_request = [];
                $canonical_request[] = "PUT";
                $canonical_request[] = "/" . $content_title;
                $canonical_request[] = "";
                $canonical_request[] = $canonical_headers;
                $canonical_request[] = "";
                $canonical_request[] = $signed_headers;
                $canonical_request[] = hash('sha256', $content);
                $canonical_request = implode("\n", $canonical_request);
                $hashed_canonical_request = hash('sha256', $canonical_request);

                // AWS Scope
                $scope = [];
                $scope[] = $date;
                $scope[] = $aws_region;
                $scope[] = $aws_service_name;
                $scope[] = "aws4_request";

                // String to sign
                $string_to_sign = [];
                $string_to_sign[] = "AWS4-HMAC-SHA256"; 
                $string_to_sign[] = $timestamp; 
                $string_to_sign[] = implode('/', $scope);
                $string_to_sign[] = $hashed_canonical_request;
                $string_to_sign = implode("\n", $string_to_sign);

                // Signing key
                $kSecret = 'AWS4' . $aws_secret_access_key;
                $kDate = hash_hmac('sha256', $date, $kSecret, true);
                $kRegion = hash_hmac('sha256', $aws_region, $kDate, true);
                $kService = hash_hmac('sha256', $aws_service_name, $kRegion, true);
                $kSigning = hash_hmac('sha256', 'aws4_request', $kService, true);

                // Signature
                $signature = hash_hmac('sha256', $string_to_sign, $kSigning);

                // Authorization
                $authorization = [
                    'Credential=' . $aws_access_key_id . '/' . implode('/', $scope),
                    'SignedHeaders=' . $signed_headers,
                    'Signature=' . $signature
                ];
                $authorization = 'AWS4-HMAC-SHA256' . ' ' . implode( ',', $authorization);

                // Curl headers
                $curl_headers = [ 'Authorization: ' . $authorization ];
                foreach($request_headers as $key => $value) {
                    $curl_headers[] = $key . ": " . $value;
                }

                $url = 'https://' . $host_name . '/' . $content_title;
                $ch = curl_init($url);
                curl_setopt($ch, CURLOPT_HEADER, false);
                curl_setopt($ch, CURLOPT_HTTPHEADER, $curl_headers);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, false);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
                curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
                curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
                curl_setopt($ch, CURLOPT_POSTFIELDS, $content);
                curl_exec($ch);
                $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
                if($http_code != 200){
                    echo "Error AWS";
                }
                if($http_code == 200){
                    $logo_en = $bucket.$content_title;
                }
        
                
            }
            else
            {
                $message = '<p style="color:red; font-size:12px;">Extensión de imagen no válida. Verifica que tu archivo tenga uno de los siguientes formatos: ' . implode(', ', $allowedfileExtensions).'</p>';
                echo $message;
                exit();
            }
        }
        else
        {
            $message = '<p style="color:red; font-size:12px;">Error en subida de imagen (EN):<br></p> ';
            $message .= '<p style="color:red; font-size:12px;">Error:' . $_FILES['logo_en']['error'].'</p>';
            echo $message;
            exit();
        }
        echo $message;
    }


    //////////////SUBIR ARCHIVO

    if($_FILES['archivo_en']['size'] > 0){

        if (isset($_FILES['archivo_en']) && $_FILES['archivo_en']['error'] === UPLOAD_ERR_OK)
        {
            // get details of the uploaded file
            $fileTmpPath2 = $_FILES['archivo_en']['tmp_name'];
            $fileName2 = $_FILES['archivo_en']['name'];
            $fileSize2 = $_FILES['archivo_en']['size'];
            $fileType2 = $_FILES['archivo_en']['type'];
            $fileNameCmps2 = explode(".", $fileName2);
            $fileExtension2 = strtolower(end($fileNameCmps2));
        
            // sanitize file-name
            $newFileName2 = $nombrearchivo_en.$lang. '.' . $fileExtension2;

            // check if file has one of the following extensions
            $allowedfileExtensions2 = array('doc', 'docx', 'xls', 'xlsx', 'pdf', 'zip');
        
            if (in_array($fileExtension2, $allowedfileExtensions2))
            {
            ///////////////SUBIR A AWS
                /// AWS API keys
                $aws_access_key_id = 'AKIA4EFX4JXF3WUEDZUY';
                $aws_secret_access_key = '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';
                // Bucket
                $bucket_name = 'indeval-webdocs-publico-01122020';
                // AWS region and Host Name (Host names are different for each AWS region)
                // As an example these are set to us-east-1 (US Standard)
                $aws_region = 'us-east-1';
                $host_name = $bucket_name . '.s3.amazonaws.com';

                // Server path where content is present. This is just an example
                //$content_path = $dest_path;
                $content2 = file_get_contents($fileTmpPath2);

                // AWS file permissions
                $content_acl = 'public-read';

                // MIME type of file. Very important to set if you later plan to load the file from a S3 url in the browser (images, for example)
                
                $content_type2 = $fileExtension;

                if($content_type2 == 'image/svg' ){ $content_type2 = "image/svg+xml";}
                if($content_type2 == 'zip' ){ $content_type2 = "application/zip";}
                if($content_type2 == 'doc' || $content_type2 == 'docx' ){ $content_type2 = "application/msword";}
                if($content_type2 == 'xls' || $content_type2 == 'xlsx' ){ $content_type2 = "application/vnd.ms-excel";}
                // Name of content on S3
                $content_title2 = 'docs/dividendos/en/'.$newFileName2;

                // Service name for S3
                $aws_service_name = 's3';

                // UTC timestamp and date
                $timestamp = gmdate('Ymd\THis\Z');
                $date = gmdate('Ymd');

                // HTTP request headers as key & value
                $request_headers = array();
                $request_headers['Content-Type'] = $content_type2;
                $request_headers['Date'] = $timestamp;
                $request_headers['Host'] = $host_name;
                $request_headers['x-amz-acl'] = $content_acl;
                $request_headers['x-amz-content-sha256'] = hash('sha256', $content2);
                // Sort it in ascending order
                ksort($request_headers);

                // Canonical headers
                $canonical_headers = [];
                foreach($request_headers as $key => $value) {
                    $canonical_headers[] = strtolower($key) . ":" . $value;
                }
                $canonical_headers = implode("\n", $canonical_headers);

                // Signed headers
                $signed_headers = [];
                foreach($request_headers as $key => $value) {
                    $signed_headers[] = strtolower($key);
                }
                $signed_headers = implode(";", $signed_headers);

                // Cannonical request 
                $canonical_request = [];
                $canonical_request[] = "PUT";
                $canonical_request[] = "/" . $content_title2;
                $canonical_request[] = "";
                $canonical_request[] = $canonical_headers;
                $canonical_request[] = "";
                $canonical_request[] = $signed_headers;
                $canonical_request[] = hash('sha256', $content2);
                $canonical_request = implode("\n", $canonical_request);
                $hashed_canonical_request = hash('sha256', $canonical_request);

                // AWS Scope
                $scope = [];
                $scope[] = $date;
                $scope[] = $aws_region;
                $scope[] = $aws_service_name;
                $scope[] = "aws4_request";

                // String to sign
                $string_to_sign = [];
                $string_to_sign[] = "AWS4-HMAC-SHA256"; 
                $string_to_sign[] = $timestamp; 
                $string_to_sign[] = implode('/', $scope);
                $string_to_sign[] = $hashed_canonical_request;
                $string_to_sign = implode("\n", $string_to_sign);

                // Signing key
                $kSecret = 'AWS4' . $aws_secret_access_key;
                $kDate = hash_hmac('sha256', $date, $kSecret, true);
                $kRegion = hash_hmac('sha256', $aws_region, $kDate, true);
                $kService = hash_hmac('sha256', $aws_service_name, $kRegion, true);
                $kSigning = hash_hmac('sha256', 'aws4_request', $kService, true);

                // Signature
                $signature = hash_hmac('sha256', $string_to_sign, $kSigning);

                // Authorization
                $authorization = [
                    'Credential=' . $aws_access_key_id . '/' . implode('/', $scope),
                    'SignedHeaders=' . $signed_headers,
                    'Signature=' . $signature
                ];
                $authorization = 'AWS4-HMAC-SHA256' . ' ' . implode( ',', $authorization);

                // Curl headers
                $curl_headers = [ 'Authorization: ' . $authorization ];
                foreach($request_headers as $key => $value) {
                    $curl_headers[] = $key . ": " . $value;
                }

                $url = 'https://' . $host_name . '/' . $content_title2;
                $ch = curl_init($url);
                curl_setopt($ch, CURLOPT_HEADER, false);
                curl_setopt($ch, CURLOPT_HTTPHEADER, $curl_headers);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, false);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
                curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
                curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
                curl_setopt($ch, CURLOPT_POSTFIELDS, $content2);
                curl_exec($ch);
                $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
                if($http_code != 200){
                    echo "Error AWS";
                }
                if($http_code == 200){
                    $archivo_en = $bucket.$content_title2;
                }
        
                
            }
            else
            {
                $message = '<p style="color:red; font-size:12px;">Extensión de archivo no válida. Verifica que tu archivo tenga uno de los siguientes formatos: ' . implode(', ', $allowedfileExtensions).'</p>';
                echo $message;
                exit();
            }
        }
        else
        {
            $message = '<p style="color:red; font-size:12px;">Error en subida de archivo:<br></p> ';
            $message .= '<p style="color:red; font-size:12px;">Error:' . $_FILES['archivo_en']['error'].'</p>';
            echo $message;
            exit();
        }
        echo $message;
    }


    ///////////////////////PETICIÓN GRAPH CMS
    $curl = curl_init();
    curl_setopt_array($curl, array(
        CURLOPT_URL => 'https://api-us-east-1.graphcms.com/v2/ckkxmrn6cw3ga01ywc1spb2qu/master',
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',

        CURLOPT_POSTFIELDS =>'{"query":"mutation MyMutation {\\r\\n  createDividendoEventoSic(data: {archivo: \\"'.$archivo_en.'\\", estatus: \\"borrador\\", fecha: \\"'.$fecha_en.'\\", resumen: \\"'.$resumen_en.'\\", titulo: \\"'.$titulo_en.'\\", localizations: {create: {data: {archivo: \\"'.$archivo_es.'\\",  estatus: \\"borrador\\", fecha: \\"'.$fecha_es.'\\",  resumen: \\"'.$resumen_es.'\\", titulo: \\"'.$titulo_es.'\\"}, locale: es_MX}}}) {\\r\\n    id\\r\\n  }\\r\\n}\\r\\n","variables":{}}',

        CURLOPT_HTTPHEADER => array(
          'Content-Type: application/json',
          'Cookie: __cfduid=da2693cdfd39b7377a8a05e305da45b8f1613001694'
        ),
      ));

    $response = curl_exec($curl);
    curl_close($curl);
    echo $response;

    $jsonrespuesta = json_decode($response, true);
    $id = $jsonrespuesta['data']['createDividendoEventoSic']['id'];
    //echo $id;

    if(strlen($id)>10){

        $curl2 = curl_init();

        curl_setopt_array($curl2, array(
        CURLOPT_URL => 'https://api-us-east-1.graphcms.com/v2/ckkxmrn6cw3ga01ywc1spb2qu/master',
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
        CURLOPT_POSTFIELDS =>'{"query":"mutation MyMutation {\\r\\n  publishDividendoEventoSic(where: {id: \\"'.$id.'\\"}, to: PUBLISHED, locales: es_MX) {\\r\\n    id\\r\\n  }\\r\\n}\\r\\n","variables":{}}',
        CURLOPT_HTTPHEADER => array(
            'Content-Type: application/json',
            'Cookie: __cfduid=da2693cdfd39b7377a8a05e305da45b8f1613001694'
        ),
        ));

        $response2 = curl_exec($curl2);
        curl_close($curl2);
        //echo $response;
    
        $jsonrespuesta2 = json_decode($response2, true);
        $id2 = $jsonrespuesta2['data']['publishDividendoEventoSic']['id'];

        if(strlen($id2)>10){
            echo '
            <script>
                $("#formnew").trigger("reset");
                $("#formnew").trigger("reset");
                $("#respuestanew").append("<h5>Dividendo añadido correctamente.</h5>");
            
                setTimeout(() => {
                    $(".popUpNew").fadeOut();        
                }, 3000);
            </script>';
        }


    }

    else{
        $errorclass ="class='errormensaje'"; 
        echo '
        <script>
            $("#respuestanew").append("<p '.$errorclass.'>OCurrió un error al añadir el contenido. Verifica la información o intenta nuevamente en unos minutos.</p>");

            setTimeout(() => {
                //$(".popUpNew").fadeOut();        
            }, 3000);
        </script>';
    }



